/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// FlowApi - struct for FlowApi
type FlowApi struct {
	Api *Api
}

// ApiAsFlowApi is a convenience function that returns Api wrapped in FlowApi
func ApiAsFlowApi(v *Api) FlowApi {
	return FlowApi{
		Api: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *FlowApi) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into Api
	err = newStrictDecoder(data).Decode(&dst.Api)
	if err == nil {
		jsonApi, _ := json.Marshal(dst.Api)
		if string(jsonApi) == "{}" { // empty struct
			dst.Api = nil
		} else {
			match++
		}
	} else {
		dst.Api = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.Api = nil

		return fmt.Errorf("data matches more than one schema in oneOf(FlowApi)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(FlowApi)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src FlowApi) MarshalJSON() ([]byte, error) {
	if src.Api != nil {
		return json.Marshal(&src.Api)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *FlowApi) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.Api != nil {
		return obj.Api
	}

	// all schemas are nil
	return nil
}

type NullableFlowApi struct {
	value *FlowApi
	isSet bool
}

func (v NullableFlowApi) Get() *FlowApi {
	return v.value
}

func (v *NullableFlowApi) Set(val *FlowApi) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowApi) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowApi) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowApi(val *FlowApi) *NullableFlowApi {
	return &NullableFlowApi{value: val, isSet: true}
}

func (v NullableFlowApi) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowApi) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
